/* global functions and definitions */

#define MAX_CHILDREN 3

typedef enum {CmdT, DecT} NodeType;
typedef enum {ProgT, AssT, CondT, IterT, NullT, ReadT, WriteT, OpT, VarT} CmdType;
typedef enum {IdT} DecType;

typedef int TokenType;

typedef struct Node {
	struct Node *child[MAX_CHILDREN];
	struct Node *sibling;
	
	NodeType nodetype;
	union {
		CmdType cmd;
		DecType dec;
	} type;

	union {
		TokenType op;
		int val;
		char *name;
	} attr;
	
} TreeNode;

int yylex();
int yyparse();

TreeNode *newcmdnode(CmdType);
TreeNode *newdecnode(DecType);
